from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String, File

Query_Testlists_V0_1_0 = CommandToolBuilder(tool="query_testlists", base_command=["query_testlists"], inputs=[ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="Print debug information (very verbose) to file /query_testlists.log")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Add additional context (time and file) to log messages")), ToolInput(tag="in_silent", input_type=Boolean(optional=True), prefix="--silent", doc=InputDocumentation(doc="Print only warnings and error messages")), ToolInput(tag="in_count", input_type=Boolean(optional=True), prefix="--count", doc=InputDocumentation(doc="Rather than listing tests, just give counts by category/machine/compiler.")), ToolInput(tag="in_list", input_type=String(optional=True), prefix="--list", doc=InputDocumentation(doc="Rather than listing tests, list the available options for\n--xml-category, --xml-machine, or --xml-compiler.\n(The singular and plural forms are equivalent - so '--list category'\nis equivalent to '--list categories', etc.)")), ToolInput(tag="in_show_options", input_type=Boolean(optional=True), prefix="--show-options", doc=InputDocumentation(doc="For each test, also show options for that test\n(wallclock time, memory leak tolerance, etc.).\n(Has no effect with --list or --count options.)")), ToolInput(tag="in_define_test_types", input_type=Boolean(optional=True), prefix="--define-testtypes", doc=InputDocumentation(doc="At the top of the list of tests, define all of the possible test types.\n(Has no effect with --list or --count options.)")), ToolInput(tag="in_xml_category", input_type=String(optional=True), prefix="--xml-category", doc=InputDocumentation(doc="Only include tests in this category; default is all categories.")), ToolInput(tag="in_xml_machine", input_type=String(optional=True), prefix="--xml-machine", doc=InputDocumentation(doc="Only include tests for this machine; default is all machines.")), ToolInput(tag="in_xml_compiler", input_type=String(optional=True), prefix="--xml-compiler", doc=InputDocumentation(doc="Only include tests for this compiler; default is all compilers.")), ToolInput(tag="in_xml_test_list", input_type=File(optional=True), prefix="--xml-testlist", doc=InputDocumentation(doc="Path to testlist file from which tests are gathered;\ndefault is all files specified in config_files.xml.\n"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Query_Testlists_V0_1_0().translate("wdl", allow_empty_container=True)

